#!/usr/bin/perl -T
#$Id: PID_slow_control.pl,v 1.13 2015/06/18 14:42:21 sqko Exp $
use strict;
use warnings;
use RFC::Rig;
use RFC::Visitor;
die "No rig specified!\n" unless (@ARGV);
my $v = RFC::DisableProglogVisitor->new();
sleep(10);
my $rig = RFC::Rig->new(shift);
$rig->check_run;
$rig->Accept($v);
foreach my $name ($rig->list_devices('PID'))
{
    my $d = $rig->get_device('PID',$name);
    next if (!defined($d) || $d->fast); ## only handle the slow devices ##
    $d->control();
    $d->store();
}
$rig->DESTROY();


